#!/usr/bin/env python3

from Crypto.Util.number import *
from flag import flag

def make_prime(nbit):
	while True:
		p = 2
		for _ in range(nbit >> 5):
			p *= getPrime(nbit >> 4)
		p += 1
		if isPrime(p):
			return p

def encrypt(msg, pubkey):
	m = bytes_to_long(msg)
	assert m < pubkey
	c = pow(m, 0x10001, pubkey)
	return c

nbit = 512
p = make_prime(512)
q = getPrime(2 * nbit - p.bit_length())

pubkey = p * q ** 2
enc = encrypt(flag, pubkey)

print(f'n = {pubkey}')
print(f'c = {enc}')
